//===================================================================
// Apci8284s.c
//-------------------------------------------------------------------
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "Apci8284w.h"

#define WM_APCI8284		WM_USER + 100
#define LOCALADR		0x10000
#define DMA_BUFSIZE		0xFFFF

#define INTCSR			0x68
#define DMAMODE0		0x80
#define DMAPADR0		0x84
#define DMALADR0		0x88
#define DMASIZ0			0x8c
#define DMADPR0			0x90
#define DMACSR0			0xa8


static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

BOOL	OnCreate( HWND hWnd );
BOOL	OnDestroy( void );
BOOL	OnInterrupt( void );
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

WORD	wLogSlot;
TCHAR	szbuf[2048];
PBYTE	DmaBuf;
char	szClassName[] = "TvvO";
//===================================================================
// C
//===================================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
										LPSTR lpCmdLine, int nCmdShow)
{
	MSG			msg;
	WNDCLASS	wc;
	HWND		hWnd;

	//---------------------------------------------------------------
	// DMA ]obt@ANZXpobt@m
	//---------------------------------------------------------------
	DmaBuf = (PBYTE)malloc(DMA_BUFSIZE);
	if ( DmaBuf == NULL ) {
		ResultMessage("obt@mێs");
		return FALSE;
	}
	//---------------------------------------------------------------
	// EChENXo^
	//---------------------------------------------------------------
	if (!hPrevInstance) {
		wc.style			= CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc		= WndProc;
		wc.cbClsExtra		= 0;
		wc.cbWndExtra		= 0;
		wc.hInstance		= hInstance;
		wc.hIcon			= NULL;
		wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground	= GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName		= NULL;
		wc.lpszClassName	= szClassName;
		if (!RegisterClass(&wc)) return FALSE;
	}
	//---------------------------------------------------------------
	// EChE쐬
	//---------------------------------------------------------------
	hWnd = CreateWindow(szClassName,
		"aPCI-8284",
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		hInstance,
		NULL);

	if ( hWnd == NULL ) return FALSE;
	//---------------------------------------------------------------
	// EChE\
	//---------------------------------------------------------------
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	//---------------------------------------------------------------
	// bZ[W[v
	//---------------------------------------------------------------
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (msg.wParam);
}
//===================================================================
// EChEbZ[W
//===================================================================
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {

		case WM_SHOWWINDOW:
			OnCreate(hWnd);
			break;

		case WM_APCI8284:
			OnInterrupt();
			break;

		case WM_DESTROY:
			OnDestroy();
			PostQuitMessage(0);
			break;

		default:
			return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return 0;
}
//===================================================================
// DMA ]荞ݔɑ΂鏈
//===================================================================
BOOL OnInterrupt( void )
{
	DWORD	i,j,cnt;

	ResultMessage("DMA ]܂(DEVICE  PC)");
	//---------------------------------------------------------------
	// DMACSR0(DMA Channel 0 Command/Status Register ) ݒ
	//---------------------------------------------------------------
	if ( Apci8284wMemWriteDWord(wLogSlot,0,DMACSR0,0x08) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	//---------------------------------------------------------------
	// DMA ]pobt@ǂݍ݁A擪oCg\
	//---------------------------------------------------------------
	if ( Apci8284wDmaRead(wLogSlot,0,DmaBuf,DMA_BUFSIZE) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	wsprintf(szbuf,_T("DMA ]pobt@ǂݍ݂܂\n"));
	cnt = 0;
	for ( i = 0 ; i < 16 ; i++ ) {
		for ( j = 0 ; j < 16 ; j++ ) {
			wsprintf(szbuf,_T("%s%02X "),szbuf,DmaBuf[cnt]);
			cnt++;
		}
		wsprintf(szbuf,_T("%s\n"),szbuf);
	}
	ResultMessage(szbuf);

	return TRUE;
}
//===================================================================
// obt@ckkJ
//===================================================================
BOOL OnDestroy( void )
{
	//---------------------------------------------------------------
	// DMA ]obt@ANZXpobt@J
	//---------------------------------------------------------------
	if ( DmaBuf != NULL ) {
		free(DmaBuf);
		ResultMessage("obt@J܂");
	}
	//---------------------------------------------------------------
	// DMA ]pobt@̊J
	//---------------------------------------------------------------
	if ( Apci8284wDmaFree(wLogSlot) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	ResultMessage("DMA ]pobt@J܂");
	//---------------------------------------------------------------
	// foCX̎gpI
	//---------------------------------------------------------------
	if ( Apci8284wClose(wLogSlot) == FALSE ) {
		ErrorMessage(APCI8284_SLOT_AUTO);
		return FALSE;
	}
	wsprintf(szbuf, _T("foCX̎gpI\n\n")
					_T("LogSlot: %2d") ,
					wLogSlot);
	ResultMessage(szbuf);
	//---------------------------------------------------------------
	// DLL̃A[h
	//---------------------------------------------------------------
  	Apci8284wDllClose();

	return TRUE;
}
//===================================================================
// ckk[hcl`]Jn܂ł̏
//===================================================================
BOOL OnCreate( HWND hWnd )
{
	DWORD				dwDLLVer, dwDrvVer;
	APCI8284RESOURCE	Res;
	DWORD				i,j,cnt;
	DWORD				PhysAddr;

	//---------------------------------------------------------------
	// DLL̎gp錾
	//---------------------------------------------------------------
	if ( Apci8284wDllOpen() == FALSE ) {
		ErrorMessage(APCI8284_SLOT_AUTO);
		return FALSE;
	}
	ResultMessage("DLL[h܂B");
	//---------------------------------------------------------------
	// o[Wԍ擾
	//---------------------------------------------------------------
	if ( Apci8284wGetVersion(&dwDLLVer, &dwDrvVer) == FALSE ) {
		ErrorMessage(APCI8284_SLOT_AUTO);
		return FALSE;
	}
	wsprintf(szbuf, _T("o[Wԍ擾\n")
					_T("DLL Version: %08lxh\n")
					_T("Drv Version: %08lxh"), dwDLLVer, dwDrvVer );
	ResultMessage(szbuf);
	//---------------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------------
	wLogSlot = APCI8284_SLOT_AUTO;
	if ( Apci8284wCreate( &wLogSlot, hWnd, WM_APCI8284 ) == FALSE ) {
		ErrorMessage(APCI8284_SLOT_AUTO);
		return FALSE;
	}
	wsprintf(szbuf, _T("foCX̎gp錾\n\n")
					_T("LogSlot: %2d"), wLogSlot);
	ResultMessage(szbuf);
	//---------------------------------------------------------------
	// \[X擾
	//---------------------------------------------------------------
	if ( Apci8284wGetResource( wLogSlot, &Res ) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	wsprintf(szbuf, 
				_T("\[X擾\n")
				_T("I/O ̈搔: %d\n" ), Res.dwNumIoRegion );
	for ( i = 0 ; i < Res.dwNumIoRegion ; i++ ) {
		wsprintf( szbuf, 
				_T("%s")
				_T("I/O Address[%d]: %04xH - %04xH\n"),
				szbuf,i,
				Res.dwIoBase[i], Res.dwIoBase[i]+Res.dwIoLength[i]-1 );
	}
	wsprintf(szbuf, 
				_T("%s")
				_T("MEM ̈搔: %d\n" ), szbuf, Res.dwNumMemRegion );
	for ( i = 0 ; i < Res.dwNumMemRegion ; i++ ) {
		wsprintf( szbuf, 
				_T("%s")
				_T("MEM Address[%d]: %04xH - %04xH\n"),
				szbuf,i,
				Res.dwMemBase[i], Res.dwMemBase[i]+Res.dwMemLength[i]-1 );
	}
	wsprintf(szbuf, 
				_T("%s")
				_T("IRQ: %d\n" ), szbuf, Res.dwIrq );
	ResultMessage(szbuf);
	//---------------------------------------------------------------
	// DMA ]pobt@̊m
	//---------------------------------------------------------------
	if ( Apci8284wDmaAlloc(wLogSlot,DMA_BUFSIZE,&PhysAddr) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	wsprintf(szbuf,	_T("DMA ]pobt@mۂ܂\n")
					_T("AhX = %xH\n")
					_T("TCY = %xH"),PhysAddr,DMA_BUFSIZE);
	ResultMessage(szbuf);
	//---------------------------------------------------------------
	// DMA ]pobt@[NA
	//---------------------------------------------------------------
	memset( DmaBuf, 0, DMA_BUFSIZE );
	if ( Apci8284wDmaWrite(wLogSlot,0,DmaBuf,DMA_BUFSIZE) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	ResultMessage("DMA ]pobt@[NA܂");
	//---------------------------------------------------------------
	// DMA ]pobt@ǂݍ݁A擪oCg\
	//---------------------------------------------------------------
	if ( Apci8284wDmaRead(wLogSlot,0,DmaBuf,DMA_BUFSIZE) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	wsprintf(szbuf,_T("DMA ]pobt@ǂݍ݂܂\n"));
	cnt = 0;
	for ( i = 0 ; i < 16 ; i++ ) {
		for ( j = 0 ; j < 16 ; j++ ) {
			wsprintf(szbuf,_T("%s%02X "),szbuf,DmaBuf[cnt]);
			cnt++;
		}
		wsprintf(szbuf,_T("%s\n"),szbuf);
	}
	ResultMessage(szbuf);
	ResultMessage("DMA ]Jn܂(DEVICE  PC)");
	//---------------------------------------------------------------
	// INTCSR(Interrupt Control/Status Register) ݒ
	//---------------------------------------------------------------
	if ( Apci8284wMemWriteDWord(wLogSlot,0,INTCSR,0x40100) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	//---------------------------------------------------------------
	// DMAMODE0(DMA Channel 0 Mode Register) ݒ
	//---------------------------------------------------------------
	if ( Apci8284wMemWriteDWord(wLogSlot,0,DMAMODE0,0x20441) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	//---------------------------------------------------------------
	// DMAPADR0(DMA Channel 0 PCI Address Register ) ݒ
	//---------------------------------------------------------------
	if ( Apci8284wMemWriteDWord(wLogSlot,0,DMAPADR0,PhysAddr) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	//---------------------------------------------------------------
	// DMALADR0(DMA Channel 0 Local Address Register ) ݒ
	//---------------------------------------------------------------
	if ( Apci8284wMemWriteDWord(wLogSlot,0,DMALADR0,LOCALADR) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	//---------------------------------------------------------------
	// DMASIZ0(DMA Channel 0 Transfer Size Register ) ݒ
	//---------------------------------------------------------------
	if ( Apci8284wMemWriteDWord(wLogSlot,0,DMASIZ0,DMA_BUFSIZE) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	//---------------------------------------------------------------
	// DMADPR0(DMA Channel 0 Descriptor Pointer Register ) ݒ
	//---------------------------------------------------------------
	if ( Apci8284wMemWriteByte(wLogSlot,0,DMADPR0,0x08) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}
	//---------------------------------------------------------------
	// DMACSR0(DMA Channel 0 Command/Status Register ) ݒ
	//---------------------------------------------------------------
	if ( Apci8284wMemWriteByte(wLogSlot,0,DMACSR0,0x03) == FALSE ) {
		ErrorMessage(wLogSlot);
		return FALSE;
	}

	return TRUE;
}
//-------------------------------------------------------------------
// ʂ\
//-------------------------------------------------------------------
static void	ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, "aPCI-8284", MB_OK | MB_ICONINFORMATION);
}
//-------------------------------------------------------------------
// G[bZ[W\ďI
//-------------------------------------------------------------------
static void	ErrorMessage(WORD wLogSlot)
{
	DWORD 	dwRes = Apci8284wGetLastError(wLogSlot);
	TCHAR	szbuf[50];

	switch(dwRes) {
		case APCI8284_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxH") , GetLastError());
			break;

		case APCI8284_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aPCI-8284 error\n\n")
							_T("Error code: %08lxH") , dwRes);
			break;
	}
	MessageBox(NULL, szbuf, "aPCI-8284", MB_OK | MB_ICONSTOP);
	// I
	Apci8284wClose(wLogSlot);
  	Apci8284wDllClose();
}

